<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsjseblod12 extends JPlugin
{
	function plgAnalyticsjseblod12( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) {
		
		if($name != 'jseblod12') return;
		
		$data = array('amline','amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
			
		if($name != 'jseblod12') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_cckjseblod', true) ) {
			$errors = '<h3>jSeblod Component Not Exists or Not Enabled<h3>';
			return;
		}
		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Words amount of text fields values</b>]]>",15 ,25 , array('text_size' => 16));
		
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'jseblod12' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';

	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'jseblod12') return;
		
		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$fields   = $params->get( 'fields' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby = $params->get( 'groupby', 'smonth' );
		$exclude   = $params->get( 'exclude', 3 );

		if( !$fields ) return;

		$parts = explode('^', $fields);

		$group_index = Array( "sday"   => "DAYOFYEAR(i.created)",
		                      "sweek"  => "WEEKOFYEAR(i.created)",
		                      "smonth" => "MONTH(i.created)",
		                      "syear"  => "YEAR(i.created)");

		$date_index = Array(  "sday"   => "DATE_FORMAT( i.created, '%Y-%m-%d' )",
		                      "sweek"  => "DATE_FORMAT( i.created - INTERVAL WEEKDAY(i.created) DAY, '%Y-%m-%d' )",
		                      "smonth" => "DATE_FORMAT( i.created, '%Y-%m-01' )",
		                      "syear"  => "DATE_FORMAT( i.created, '%Y-01-01' )");

		$sql_conf = " SELECT conf.opening,conf.closing
		FROM #__jseblod_cck_configuration AS conf ";
		
		$db->setQuery ( $sql_conf );
		$result_conf = $db->loadObject ();
		
		$sql = " SELECT CONCAT(i.introtext,i.fulltext) AS text,u.username,items.title, {$date_index[$groupby]}  AS date_index, YEAR(i.created)     AS c_year,
		{$group_index[$groupby]} AS group_index
		FROM #__content AS i 
		INNER JOIN #__categories AS c ON c.id = i.catid
		INNER JOIN #__users AS u ON u.id = i.created_by, 
		#__jseblod_cck_items AS items
		WHERE i.introtext LIKE  '%" . $result_conf->opening . 'jseblod' . $result_conf->closing . $parts [0] . $result_conf->opening . '/jseblod' . $result_conf->closing . "%' AND items.name =  '" . $parts [1] . "' AND i.state = 1 AND c.published = 1 AND i.created BETWEEN '{$from}' AND '{$to}'";
		if (($params->get ( 'user_stick' ) && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND i.created_by = '$user_id'";
		$sql .= "  GROUP BY c_year, group_index, i.id";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		
		$regex = "#" . $result_conf->opening . "(.*?)" . $result_conf->closing . "(.*?)" . $result_conf->opening . "(/.*?)" . $result_conf->closing . "#s";
		foreach ( $result as $k => $row ) {
			preg_match_all ( $regex, $row->text, $contentMatches );
			
			if (($aKey = array_search ( $parts [1], $contentMatches [1] )) !== false) {
				$itemValue = $contentMatches [2] [$aKey];
				$value = preg_split ("/[\s]+/", $itemValue);
				foreach ($value as $k => $val)
				{
					if(strlen($val) <= $exclude)
					unset($value[$k]);
				}
				if($value)
					if (!isset($_result[$row->username][$row->date_index]) ) $_result[$row->username][$row->date_index] = count($value);
						else $_result[$row->username][$row->date_index] += count($value);
			}
		}
		foreach ( $_result AS $key => $row ) {
			foreach( $row AS $date => $amount ) {
				$graphs[$key][$date] = $amount;
			}
		}
		
		$current_date = $from;
	
		switch ( $groupby ) {
			case "sday":
				$format_series 		= '%Y %d %b';
				break;
			case "sweek" :
				$timestamp = strtotime( $current_date );
				$date_info = getdate($timestamp);
				$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %UW';
				break;
			case "smonth" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %b';
				break;
			case "syear" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y';
				break;
		}
		
		while ( strtotime( $current_date ) <= strtotime( $to ) ) {
			$serie = strftime( $format_series, strtotime( $current_date ) );
			$objChart->addSerie($current_date,$serie);
			if ( $type == 'amline')
			{
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = " 0 ";
					}
				}
			}
			$current_date = $this->incrementDate( $current_date, $groupby );
		}
		
		foreach( $graphs as $key => $graph ) {
			$objChart->addGraph($key, $key, $graph, array( 
				'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
			));
		}


	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'jseblod12') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = 0;
		if($params->get('user_stick'))
		{
			$user_id = $user->id;
		}
		if($user->gid == 25) $user_id = JRequest::getInt('user_id', $user_id);

		$fields   = $params->get( 'fields' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$exclude   = $params->get( 'exclude', 3 );

		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if( !$fields ) return;
		
		$parts = explode('^', $fields);

		$sql_conf = " SELECT conf.opening,conf.closing
		FROM #__jseblod_cck_configuration AS conf ";
		
		$db->setQuery ( $sql_conf );
		$result_conf = $db->loadObject ();
		
		$sql = " SELECT CONCAT(i.introtext,i.fulltext) AS text,u.username,items.title
		FROM #__content AS i 
		INNER JOIN #__categories AS c ON c.id = i.catid
		INNER JOIN #__users AS u ON u.id = i.created_by, 
		#__jseblod_cck_items AS items
		WHERE i.introtext LIKE  '%" . $result_conf->opening . 'jseblod' . $result_conf->closing . $parts [0] . $result_conf->opening . '/jseblod' . $result_conf->closing . "%' AND items.name =  '" . $parts [1] . "' AND i.state = 1 AND c.published = 1 AND i.created BETWEEN '{$from}' AND '{$to}'";
		if (($params->get ( 'user_stick' ) && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND i.created_by = '$user_id'";
		$sql .= "  GROUP BY i.id";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		
		$regex = "#" . $result_conf->opening . "(.*?)" . $result_conf->closing . "(.*?)" . $result_conf->opening . "(/.*?)" . $result_conf->closing . "#s";
		foreach ( $result as $k => $row ) {
			preg_match_all ( $regex, $row->text, $contentMatches );
			
			if (($aKey = array_search ( $parts [1], $contentMatches [1] )) !== false) {
				$itemValue = $contentMatches [2] [$aKey];
				$value = preg_split ("/[\s]+/", $itemValue);
				foreach ($value as $k => $val)
				{
					if(strlen($val) <= $exclude)
					unset($value[$k]);
				}
				if (!isset($_result[$row->username]) ) $_result[$row->username] = count($value);
					else $_result[$row->username] += count($value);
			}
		}

		$total = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th>'.JText::_('User').'</th>';
		$out[] = '<th width="1%">'.JText::_('Words amount').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$i = 1;
		foreach ($_result as $username => $amount)
		{
			if( $limit && $i > $limit) break;
			$out[] = '<tr><td>'.$i.'</td><td>'.$username.'</td><td align="right">'.$amount.'</td></tr>';
			$total += $amount;
			$i ++ ;
		}

		$out[] = "<tr><td></td><td><big><b>".JText::_('Total')."</b></big></td>
		<td align='right'><big><b>$total</b></big></td></tr>";

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}


	function onGetTotals( $name, $params)
	{
		if($name != 'jseblod12') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$fields   = $params->get( 'fields' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby = $params->get( 'groupby', 'smonth' );
		$exclude   = $params->get( 'exclude', 3 );

		if( !$fields ) return;

		$parts = explode('^', $fields);
		
		$sql_conf = " SELECT conf.opening,conf.closing
		FROM #__jseblod_cck_configuration AS conf ";
		
		$db->setQuery ( $sql_conf );
		$result_conf = $db->loadObject ();
		
		$sql = " SELECT CONCAT(i.introtext,i.fulltext) AS text,u.username,items.title
		FROM #__content AS i 
		INNER JOIN #__categories AS c ON c.id = i.catid
		INNER JOIN #__users AS u ON u.id = i.created_by, 
		#__jseblod_cck_items AS items
		WHERE i.introtext LIKE  '%" . $result_conf->opening . 'jseblod' . $result_conf->closing . $parts [0] . $result_conf->opening . '/jseblod' . $result_conf->closing . "%' 
		AND items.name =  '" . $parts [1] . "' AND i.state = 1 AND c.published = 1 
		AND i.created BETWEEN '{$from}' AND '{$to}'";
		if (($params->get ( 'user_stick' ) && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND i.created_by = '$user_id'";
		$sql .= "  GROUP BY i.id";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		$amount = 0;
		$regex = "#" . $result_conf->opening . "(.*?)" . $result_conf->closing . "(.*?)" . $result_conf->opening . "(/.*?)" . $result_conf->closing . "#s";
		foreach ( $result as $k => $row ) {
			preg_match_all ( $regex, $row->text, $contentMatches );
			
			if (($aKey = array_search ( $parts [1], $contentMatches [1] )) !== false) {
				$itemValue = $contentMatches [2] [$aKey];
				$value = preg_split ("/[\s]+/", $itemValue);
				foreach ($value as $k => $val)
				{
					if(strlen($val) <= $exclude)
					unset($value[$k]);
				}
				$amount += count($value);
			}
		}
		$field_name = $result[0]->title;
		$tag_length = strlen($result_conf->opening.'jseblod'.$result_conf->closing);
		$sql2 = "    SELECT count(i.id) as amount 
		FROM #__content As i 
		INNER JOIN #__jseblod_cck_types As t ON t.name=(substring(i.introtext,Locate('".$result_conf->opening.'jseblod'.$result_conf->closing."',i.introtext)+".$tag_length." , 
		Locate('".$result_conf->opening.'/jseblod'.$result_conf->closing."',i.introtext)-(Locate('".$result_conf->opening.'jseblod'.$result_conf->closing."',i.introtext)+".$tag_length.") ))"
		."\n     WHERE i.state = 1 AND t.name = '".$parts[0]."' AND i.created BETWEEN '".$from."' AND '".$to."'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql2 .= " AND i.created_by = '$user_id'";
		
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();

		if( !$result || !( $dbtotal_records >= 0 ) ) return;

		$totals = array();
		$i = 0;

		$totals[$i]['value'] = $dbtotal_records.' <i>'.JText::_( 'records').'</i>' ;
		$totals[$i++]['text'] =  JText::_( 'Total with field' ).' <b>'.$field_name.'</b>';

		$totals[$i]['value'] = $amount.' <i>'.JText::_( 'words').'</i>';
		$totals[$i++]['text'] = JText::_( ' in articles with field' ).' <b>'.$field_name.'</b>';

		return $totals;
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}

}
?>